#include "Wam.h"
#include "seqtype.h" // includes fasta.h
#include "stype.h"
#include <string>
#include <iostream>

using std::string;
using std::endl;
using std::cout;

int main(int argc, char** argv) {
  fasta data;
  data.read(argv[1]);
  Wam* wam = NULL;
  if( strstr(argv[1],"don") ) {
    wam = new Wam(9,0.0);
  } else if( strstr(argv[1],"acc") ) {
    wam = new Wam(24,0.0);
  } else {
    cout<<"failure..."<<endl;
    return -1;
  }
  fasta::const_iterator stop = data.end();
  for(fasta::const_iterator testi = data.begin(); testi != stop; ++testi ) {
    const fasta_seq& trseq = **testi;
    const string& seq = trseq.get_seq();
    //cout<<"seq: "<<seq<<endl;
    wam->update(seq,0);
  }
  wam->normalize();
  //cout<<*wam<<endl;
  return 0;
}
