#ifndef _CODECONSHMM_H
#define _CODECONSHMM_H

#include <ostream>
#include <string>
#include <vector>

class CodeConsHmm {
 public:
  state_t { eCons1 = 0, eCons2, eCons3, eNonCons3, eCodeConsHmmSize };

  CodeConsHmm();

  void print(std::ostream&) const;
  void write(const std::string&) const;
  void read(const std::string&);
  void normalize();


 public:
  std::vector<std::vector<state_t> > _init;
  std::vector<std::vector<state_t> > _trans;
};
#endif //_CONSHMM_H
