#include "OrgIdx.h"
#include <iostream>
#include <sstream>
#include <stdexcept>

using std::vector;
using std::string;
using std::endl;
using std::cout;

#if 0
void
OrgIdx::buildIdx(const vector<string>& onames) {
  for(unsigned i = 0; i < onames.size(); ++i) {
    string::size_type pos = onames[i].find('.',0);
    if( pos == string::npos ) {
      //cout<<"houstan there's a problem "<<onames[i]<<endl;
      cout<<"Organism: hack to tell me this is in the tree but not input seq"<<onames[i]<<endl;
    } else {
      ++_size;
    }
    const string str = onames[i].substr(0,pos);
    cout<<"str: "<<str<<endl;
    _hidx[str]=i;
  }
}
#endif

void
OrgIdx::add(const string& name) {
  hmap::const_iterator match = _hidx.find(name); 
  if( match == _hidx.end() ) {
    _hidx[name]=_size;
    ++_size;
    //cout<<"str: "<<name<<endl;
  }
}

unsigned 
OrgIdx::fname2idx(const string& str) const {
  string::size_type pos = str.find('.',0);
  if( pos == string::npos ) {
    //cout<<"houstan there's a problem "<<str<<endl;
    pos = str.length();
  }
  const string fstr = str.substr(0,pos);
  hmap::const_iterator match = _hidx.find(fstr);
  if( match == _hidx.end() ) {
    std::ostringstream ostrm;
    ostrm<<"whatup: "<<str<<endl;
    throw std::runtime_error(ostrm.str());
  }
  return (*match).second;
}


std::string 
OrgIdx::idx2str(unsigned idx) const {
  hmap::const_iterator match = _hidx.begin();
  const hmap::const_iterator stop = _hidx.end();
  for(; match != stop; ++match) {
    if( (*match).second == idx ) {
      return (*match).first;
    }
  }
  return "";
}
