#ifndef _BASE_H
#define _BASE_H

#include <ctype.h>

inline bool
isStop(char a, char b, char c) {
	bool c1 = tolower(a)=='t'&&tolower(b)=='a'&&tolower(c)=='a';
	bool c2 = tolower(a)=='t'&&tolower(b)=='a'&&tolower(c)=='g';
	bool c3 = tolower(a)=='t'&&tolower(b)=='g'&&tolower(c)=='a';
	return c1||c2||c3;
}

inline bool
isPy(char a) {
  const char c=tolower(a);
  return (c=='c'|| c=='t');
}

inline bool
isPr(char a) {
  const char c=tolower(a);
  return (c=='a'|| c=='g');
}

inline int
sameBaseType(char a, char b) {
  return ( (isPy(a) && isPy(b)) || (isPr(a) && isPr(b))) ? 1 : 0;
}

#if 0
inline unsigned
base2int(char ic) {
  char c = tolower(ic);
  switch(c) {
  case 'a':
    return 0x0;
  case 'c':
    return 0x1;
  case 'g':
    return 0x2;
  case 't':
    return 0x3;
  default:
    //cerr<<"non a,c,g,t code -skipping"<<endl;
    return 4;
  }
}

inline unsigned
int2base(int ic) {
  char c = tolower(ic);
  switch(c) {
  case 0:
    return 'a';
  case 1:
    return 'c';
  case 2: return 'g';
  case 3: return 't';
  default:
    return 'o';
  }
}
#endif

#endif //_BASE_H
