#ifndef _STYPE_H
#define _STYPE_H

#include <ostream>
#include "MarkovChain.h"

typedef std::pair<unsigned,unsigned> upair_t;
typedef std::pair<int,int> ipair_t;
typedef std::pair<double,double> dpair_t;

enum pred_t { eBasicFixedRate=0, eLearnedFixedRate, eBaumWelchHmmRates, 
	      eDisc1HmmRates };

enum splice_t { eTruDon=0, eFalDon, eTruAcc, eFalAcc, eSplSize };
  enum htype_t {
    eNpc,ePrc1,ePrc2,eDon,eAcc,eEmptyState
  };
typedef std::pair<MarkovChain*,int> mcpair_t;
typedef std::pair<bool,double> spair_t;
inline std::ostream& 
operator<<(std::ostream& os, const spair_t sp) {
	os<<sp.first<<" "<<sp.second;
	return os;
}
#endif // _STYPE_H
