#ifndef _Kmer_H
#define _Kmer_H

#include "MarkovChain.h"
#include <vector>
#include <ostream>

class Kmer : public MarkovChain {
 public:
  friend class IhMc;
  Kmer(int, double = 0.0, int = 4);
  Kmer(const Kmer&);
  
  ~Kmer() { }

  Model* clone() const;
  virtual void
    normalize();

};

#endif // _Kmer_H
