#ifndef _HMMCOMPONENT_H
#define _HMMCOMPONENT_H

#include <ostream>

class HmmComponent {
 public:
  virtual ~HmmComponent() { }
  virtual void update(double) = 0;
  virtual void write(std::ostream&) const = 0;
  virtual double getRate() const = 0;
  virtual double getProb() const = 0;
  virtual void transferUpdate(HmmComponent& hc) = 0;
  virtual bool operator==(const HmmComponent&) const = 0;
};

#endif // _HMMCOMPONENT_H
