#ifndef _INVSCORECACHE_H
#define _INVSCORECACHE_H

#include "SeqLabel.h"
#include "stype.h"
#include <vector>

class InvScoreCache {
 public:
  InvScoreCache(const SeqLabel& sl);

  const SeqLabel& getBnd() const { return _bnd; }
  std::vector<spair_t>& getInvScore(unsigned idx) { return _invScore[idx]; }
    
 private:
  SeqLabel _bnd;
  std::vector<std::vector<spair_t> > _invScore;
};

#endif // _INVSCORECACHE_H
