#ifndef _ORGIDX_H
#define _ORGIDX_H

#include <ext/hash_map>
#include <vector>
#include <string>

class OrgIdx {
 public:
  OrgIdx() : _size(0) { }
  
    //void
      //buildIdx(const std::vector<std::string>&);
    void
      add(const std::string&);

  unsigned size() const { return _size; }

  unsigned fname2idx(const std::string&) const;	   
  std::string idx2str(unsigned) const;	   

 private:
  struct my_hash
  {
    size_t operator()(const std::string& __s) const { 
      return __gnu_cxx::__stl_hash_string(__s.c_str()); }
  };
  typedef __gnu_cxx::hash_map<std::string, unsigned,my_hash> hmap;
  hmap _hidx;
  unsigned _size;
};

#endif // _ORGIDX_H
