#ifndef _PREDMODEL_H
#define _PREDMODEL_H

#include "stype.h"
#include <string>
#include <vector>

class PredModel {
 public:
  void
    train(const fasta&); 

  virtual std::vector<spair_t>
    scoreInterval(int,int, const std::vector<std::string*>&, int, int, cname_t, bool = false) = 0;
  virtual std::vector<spair_t>
    scoreInterval1(const SeqLabel&, const SeqLabel&, const std::vector<std::string*>&, int, int, bool = false) = 0;
  virtual void
    consTrain(const fasta&, const std::string&) = 0; 
};

#endif // _PREDMODEL_H
