#ifndef _SUBMODEL_H
#define _SUBMODEL_H

#include <string>
#include <ostream>

class SubModel {
 public:
  /**
   * return probablity of string b mutated from string a
   * @param = string b
   * @param = string a
   * @param = branch length
   */
virtual ~SubModel() { }
  virtual double 
  getProb(const std::string&,const std::string&, double) const = 0;

  virtual double 
  getProb(char,char, double) const = 0;

  virtual void print(std::ostream&) const = 0;
};

#endif // _SUBMODEL_H
